%define pkg_lib   1
%define pkg_devel 1

Name:           stackage-dist-pkg-lts-6.1-tagged
Version:        0.8.4
Release:        1%{?dist}
Summary:        Pre-compilation of a Stackage package
Group:          System Environment/Development Tools
License:        Various
URL:            https://www.stackage.org

BuildRoot:      %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
Source0:        nothing.txt

BuildRequires:  stackage-dist-snapshot-lts-6.1
BuildRequires:  stackage-dist-ghc-7.10.3
BuildRequires:  stackage-dist-indices
BuildRequires:  stackage-dist-source-cache-lts-6.1

BuildRequires:  git
BuildRequires:  chrpath
BuildRequires:  gmp-devel

%if 0%{?fedora} >= 24
# GHC builds need tinfo.so.5
BuildRequires:  ncurses-compat-libs

%endif


# @@REQUIRES@@

%description

%package lib
Summary:        Pre-compilation of a Stackage package
Requires: stackage-dist-pkg-lts-6.1-tagged
%description lib

%package devel
Summary:        Pre-compilation of a Stackage package
Requires: stackage-dist-pkg-lts-6.1-tagged-lib
Requires: stackage-dist-snapshot-lts-6.1
Requires: stackage-dist-ghc-7.10.3


%description devel

%prep

%build

## Either unset LDFLAGS (which seems to be '-Wl,-Bsymbolic-functions -Wl,-z,relro' in
## launchpad) or:

%define stackage_dist \
	export LC_ALL=en_US.UTF-8 \
        export LANG=en_US.UTF-8 \
        export LANGUAGE=en_US.UTF-8 \
	export STACK_SYSTEM_ROOT=%{_libexecdir}/stackage-dist \
        export STACK_ROOT=`pwd`/stack-root \
        export PATH=${STACK_SYSTEM_ROOT}/bin:$PATH \
        unset LDFLAGS

%stackage_dist

mkdir -p $STACK_ROOT
mkdir -p $STACK_ROOT/global-project

echo "resolver: lts-6.1" >  $STACK_ROOT/global-project/stack.yaml
echo "flags: {}"              >> $STACK_ROOT/global-project/stack.yaml
echo "extra-package-dbs: []"  >> $STACK_ROOT/global-project/stack.yaml
echo "packages: []"           >> $STACK_ROOT/global-project/stack.yaml
echo "extra-deps: []"         >> $STACK_ROOT/global-project/stack.yaml

echo "{}" > $STACK_ROOT/config.yaml


%install
%stackage_dist

ls -l %{_libexecdir}/stackage-dist/snapshots/x86_64-linux/lts-6.1/7.10.3/pkgdb

stack --resolver=lts-6.1 -v install tagged

INSTALLED_STACKAGE_ROOT=$RPM_BUILD_ROOT/%{_libexecdir}/stackage-dist
mkdir -p $INSTALLED_STACKAGE_ROOT
cp -a $STACK_ROOT/snapshots $INSTALLED_STACKAGE_ROOT
rm -f $(find $INSTALLED_STACKAGE_ROOT -name package.cache)
stack relocate \
      $INSTALLED_STACKAGE_ROOT \
      %{_libexecdir}/stackage-dist \
      --source $STACK_ROOT

find $RPM_BUILD_ROOT -name \*.so \
    | sed "s#$RPM_BUILD_ROOT##g" \
    > lib.files

find $RPM_BUILD_ROOT -name \*.a -o -name \*.hi \
      -o -name \*.conf -o -name \*.dyn_hi \
    | sed "s#$RPM_BUILD_ROOT##g" \
	  > devel.files

%files
%{_libexecdir}/stackage-dist/snapshots/*/*/*/doc

%files lib -f lib.files

%files devel -f devel.files

%define ghc_pkg_recache \
	export PATH=%{_libexecdir}/stackage-dist/programs/x86_64-linux/ghc-7.10.3/bin:$PATH \
        SNAPDIR=%{_libexecdir}/stackage-dist/snapshots/x86_64-linux/lts-6.1/7.10.3 \
        PKGDB=${SNAPDIR}/pkgdb \
        ghc-pkg --package-db=${PKGDB} recache

%post devel
%ghc_pkg_recache

%postun devel
%ghc_pkg_recache

%changelog
